Subject: Re: [PATCH net-next] selftests: drv-net: rss: validate min RSS table size

From: Willem de Bruijn <[email-masked]>
Date: Sat, 31 Jan 2026 13:38:00 -0500

Reviewed-by: Willem de Bruijn <[email-masked]>

Jakub Kicinski wrote:
> On Sat, 31 Jan 2026 12:18:55 -0500 Willem de Bruijn wrote:
> > > +def _test_rss_indir_size(cfg, qcnt, context=0):
> > > +    """Test that indirection table size is at least 4x queue count."""
> > > +    ethtool(f"-L {cfg.ifname} combined {qcnt}")  
> > 
> > Remind me: does this work with devices that advertise RX N TX N rather
> > than combined N?
> 
> It doesn't. But I haven't seen a device which doesn't at least
> advertise combined made in this decade. I started typing this with

I was indeed thinking of mlx4 as one example.

> support for "rx" vs "combined" initially, but it complicates the code
> for no real benefit.
> 
> If a driver which doesn't have "combined" starts reporting results 
> to NIPA I'll care, right now - CBA.

Fair. It's good to gracefully and skip on older platforms.
I guess the test does that by virtue of the KsftSkipEx if
combined-max < 3. Ack.

> > > +    rss = _get_rss(cfg, context=context)
> > > +    indir = rss['rss-indirection-table']
> > > +    ksft_ge(len(indir), 4 * qcnt, "Table smaller than 4x")
> > > +    return len(indir)
> > > +
> > > +
> > > +@ksft_variants([
> > > +    KsftNamedVariant("main", False),
> > > +    KsftNamedVariant("ctx", True),
> > > +])
> > > +def indir_size_4x(cfg, create_context):
> > > +    """
> > > +    Test that the indirection table has at least 4 entries per queue.
> > > +    Empirically network-heavy workloads like memcache suffer with the 33%
> > > +    imbalance of a 2x indirection table size.
> > > +    4x table translates to a 16% imbalance.
> > > +    """
> > > +    channels = cfg.ethnl.channels_get({'header': {'dev-index': cfg.ifindex}})
> > > +    ch_max = channels.get('combined-max', 0)  
> > 
> > Same here: not all drivers set this.
> > 
> > Perhaps we should skip if absent?
> > 
> > And does combined-max mean all queues across all contexts, or per
> > context?
> 
> Could you rephrase? Not sure I understand.

I implicitly assumed mutually exclusive sets of queues associated with
the two contexts.

If max channels is a driver global limit, then cannot 
exclusively assign max channels to both contexts.

But my assumption was wrong of course. Multiple RSS contexts can have
the same queues in their indirection tables. And this test does not
include any flow steering to an exclusive (set of) queue(s) for the
additional context.

I had not previously given any thought to how additional contexts'
indirection tables are (expected by the kernel to be) initialized.

> channels are interrupts, we use it in place of max Rx queues because 
> we don't have an API to allocate queues directly.
> 
> When queue count is changed and the user did not set the indirection
> table of the main context the main context's indir table is auto-
> -repopulated. It may also be resized.
> 
> The indir tables of additional contexts are not repopulated.
> We do not have the concept of "default" indirection table in 
> an additional context because it has no practical use (just use
> the main table if you don't care about the queue selection!?)
> Since we don't have an explicit API to size them, (yet),
> we expect the size of additional contexts to follow the size 
> of the main indirection table.
> 
> If a table is resized the expectation should be that the driver
> folds/unfolds the existing table eg [0, 1, 0, 1] can fold into [0, 1]
> or unfold into [0, 1, 0, 1, 0, 1, 0, 1]. Resizing tables of additional
> contexts is currently broken / no possible. My colleague is supposed
> to be working on fixing that but appears to be making slow progress :/
> 
> > The test seems to imply the second. My intuition was the
> > first. Is it clearly defined across devices. per ethtool_channels,
> > seems per device?
> > 
> >   * @max_combined: Read only. Maximum number of combined channel the driver
> >   *      support. Set of queues RX, TX or other.
>